/*
 * anhOptimal.c
 *
 *  Created on: 3 March 2014
 *      Author: Anthony
 */

#ifndef ANHOPTIMAL_H_
#define ANHOPTIMAL_H_


#include "type.h"
#include "metric.h"
#include "heuristic.h"
#include "init.h"
#include "conflictOptimal.h"
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

/* Return 1 if the path is vaid, i.e. if there is a radio/freq allocated on the path between src and dest	*/
/* returns 0 otherwise.												*/
int validPath(int pathNumber);

//Compute the nextID: the id of the node such that > nodeID and has a valid route
//Return nbOfNodes if there is no such node. 
int computeNextID(int nodeID, int nbOfRoutes);

//Compute the nextID: the id of the node such that > nodeID and has a valid route
//Return nbOfNodes if there is no such node. 
int computeNextIDAllocation(int nodeID, int nbOfRoutes);

int usedFrequency(int nodeID, int freq);


//Une fois que les freq ont ete alloues aux radios il y a encore plusieurs possibilites au niveau de l'assignation
//c'est a dire que l'on peut avoir plusieurs freq/cartes communs a deux voisins. Ce choix impactant la fonction de cout
//On est oblige d'etudier tous les choix possibles. 
void updateFreqRadioRecursive(int nodeID, int nbOfRoutes, float* result);

void allocateFrequencyRecursive(int nodeID, int nbOfRoutes, int pathNumber, float* result);

float throughputOptimal(int nbOfRoutes);

void printAllocation(int nbOfRoutes);


#endif

